<?
#namespace Intradesk;

class Task {

    #Адрес вашей системы Intradesk (без https://)
    private $COMPANY="qweqweqwe1.intradesk.ru";
    #ID группы в которую будет попадать клиент
    private $GROUP_ID = "";
    #ID ответственного менеджера (можно посмотреть на площадке intradesk)
    private $MANAGER_ID = 248719;
    #Соль для шифрования кода верификации Email
    private $SALT = "QWECX";
    #Email отправителя
    private $EMAIL = "test@demo.xhost.intravision.ru";


    #Токен для доступа к площадке
    #(подробное описание получения токена описано на сайте intradesk.ru)
    private $ACCESS_TOKEN="6F78A3420****C5198B124****";


    #Генерация кода для верификации Email
    #(рекомендуется использовать свой вариант валидации EMAIL)
    function GetCode() {
        return md5(date("F j, Y, g:i a").$this->SALT);
    }

    #Генерация короткого кода, для отпрвки в Email
    #(рекомендуется использовать свой вариант валидации EMAIL)
    function CodeConvert($code) {
        return mb_substr(md5($code).$this->SALT,13,5);
    }

    #Отправка короткого кода на email
    #(рекомендуется использовать свой вариант валидации EMAIL)
    function SendMailCode($mail, $code){
        $to      = $mail;
        $subject = 'Код подтверждения';
        $message = 'Ваш код подтверждения: '.$this->CodeConvert($code);
        $headers = 'From: '. $this->EMAIL . "\r\n" .
            'Reply-To: '. $this->EMAIL . "\r\n" .
            'X-Mailer: PHP/' . phpversion();

        mail($to, $subject, $message, $headers);
    }

    #POST запрос через CURL
    function post($url, $post_data, $header_data) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header_data);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);

        $output = curl_exec($ch);
        curl_close($ch);
        return $output;
    }

    #GET запрос через CURL
    function get($url, $header_data, $get){
        $query = http_build_query($get);

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url."?".$query);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header_data);
        curl_setopt($ch, CURLOPT_POST, 0);
        $output = curl_exec($ch);
        curl_close($ch);
        return $output;

    }

    #Создание клиента (физ лицо), если пользователя с таким Email нет в системе
    function CreateFizUser($FirstName,$LastName,$MiddleName='',$pass, $email,$phoneNumber=''){
        $result = $this->GetUser($email);

        if(empty($result["value"])){
            $URL = "https://apigw.intradesk.ru/settings/api/v3/clients/PhysicalPersons?ApiKey=".$this->ACCESS_TOKEN;
            $HEADER = ["Content-Type: application/json"];

            //$raw["description"] = "";
            $raw["contactPersonFirstName"] = $FirstName;
            $raw["contactPersonEmail"] = $email;
            $raw["contactPersonLastName"] = $LastName;
            $raw["contactPersonMiddleName"] = $MiddleName;
            $raw["setContactPerson"] = true;
            $raw["password"] = $pass;
            $phoneArray["phoneNumber"] = $phoneNumber;
            $phoneArray["phoneExt"] = "";
            $phoneArray["default"] = true;
            $raw["contactPersonPhoneNumbersList"][] = $phoneArray;
            $raw["timeZoneCode"] = "Europe/Moscow";
            //$raw["userGroupTags"]["id"] =
            $raw["managerId"] = $this->MANAGER_ID;
            $BODY = json_encode($raw, JSON_UNESCAPED_UNICODE);

            $this->post($URL, $BODY, $HEADER);
            $result = $this->GetUser($email);
        }


        return $result;
    }

    #Создание клиента (юр лицо), если пользователя с таким Email нет в системе
    function createUrUser($companyName, $inn, $site, $FirstName ,$LastName ,$MiddleName='' ,$pass ,$email ,$phoneNumber='') {

        $result = $this->GetUser($email);

        if(empty($result["value"])) {
            $URL = "https://apigw.intradesk.ru/settings/api/v3/clients/LegalEntities?ApiKey=" . $this->ACCESS_TOKEN;
            $HEADER = ["Content-Type: application/json"];

            $raw["name"] = $companyName;
            $raw["taxpayerNumber"] = $inn;
            $raw["web"] = $site;
            $raw["contactPersonFirstName"] = $FirstName;
            $raw["contactPersonLastName"] = $LastName;
            $raw["contactPersonMiddleName"] = $MiddleName;
            $raw["contactPersonEmail"] = $email;
            $raw["email"] = $email;
            $raw["setContactPerson"] = true;
            $raw["password"] = $pass;
            $phoneArray["phoneNumber"] = $phoneNumber;
            $phoneArray["phoneExt"] = "";
            $phoneArray["default"] = true;
            $raw["contactPersonPhoneNumbersList"][] = $phoneArray;
            $raw["timeZoneCode"] = "Europe/Moscow";
            $raw["managerId"] = $this->MANAGER_ID;


            $BODY = json_encode($raw, JSON_UNESCAPED_UNICODE);

            $this->post($URL, $BODY, $HEADER);

            $result = $this->GetUser($email);

        }

        return $result;
    }

    #Поиск пользователья в системе по Email
    function GetUser($email){
        $URL = "https://apigw.intradesk.ru/settings/odata/v2/Clients";
        $GET = array(
            "ApiKey" => $this->ACCESS_TOKEN,
            "\$skip" => 0,
            "\$orderby" => "id desc",
            "\$filter" => "contactPerson/email eq '{$email}' and (isArchived eq false)"
        );
        $HEADER = ["Content-Type: application/json"];

        $result = json_decode($this->get($URL, $HEADER, $GET), true);

        return $result;
    }

    #Создание заявки от указанного пользователя
    function CreateTask($title, $message, $userid, $groupid){
        $URL = "https://apigw.intradesk.ru/changes/tasks?ApiKey=".$this->ACCESS_TOKEN;
        $HEADER = ["Content-Type: application/json"];

        $raw["blocks"]["name"] = quotemeta(
            json_encode(
                array("value"=>$title)
            )
        );
        $raw["blocks"]["description"] = quotemeta(
            json_encode(
                array("value"=>$message)
            )
        );
        $raw["blocks"]["initiator"] = quotemeta(
            json_encode(
                array(
                    "value"=>array(
                        "userid"=>$userid,
                        "groupid"=>$groupid
                    )
                )
            )
        );

        $BODY = json_encode($raw, JSON_UNESCAPED_UNICODE);
        echo $BODY;
        return $this->post($URL, $BODY, $HEADER);


    }
}
?>